#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
//#inclide <qcheckbox.h>
#include <qgroupbox.h>

//#include <stdlib.h>

#include "sub_convert.h"

SubConvert::SubConvert(int *destformat) : QDialog(NULL, "sub_convert", true)
{
  this->destformat = destformat;

  QPushButton *btn_ok, *btn_cancel;
  btn_ok     = new QPushButton("OK", this);
  btn_cancel = new QPushButton("Anuluj", this);
  btn_ok    ->setGeometry(40 , 190, 80, 20);
  btn_ok    ->setDefault(true);
  btn_cancel->setGeometry(130, 190, 80, 20);
  connect(btn_ok    , SIGNAL(clicked()), SLOT(accept()));
  connect(btn_cancel, SIGNAL(clicked()), SLOT(reject()));


  QWidget *w1  = new QWidget (this);
  w1->setGeometry(10, 20, 230, 15);
  QLabel  *l1  = new QLabel  ("Docelowy format napisw:", w1);
  l1->setAutoResize(true);


  /*QVBox **/vbox1 = new QVBox(this);
  vbox1->setGeometry(10, 50, 230, 120);

  /*QButtonGroup **/grp = new QButtonGroup(1, QGroupBox::Horizontal, "", vbox1);
  grp->setExclusive(true);
  b1 = new QRadioButton("&Czasowy     00:00:00:", grp);
  b2 = new QRadioButton("&TMPlayer    0:00:00:", grp);
  b3 = new QRadioButton("&mDVDp       {000}{000}", grp);
  b4 = new QRadioButton("&MPL2          [000][000]", grp);
  b3->setChecked(true);

//  edit->setFocus();
};

//////////////////// SLOTY /////////////////
void SubConvert::accept()
{
  if (b1->isChecked()) *destformat = 1;
  if (b2->isChecked()) *destformat = 2;
  if (b3->isChecked()) *destformat = 3;
  if (b4->isChecked()) *destformat = 4;
  done(true);
}
