#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qvbox.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qgroupbox.h>

#include "sub_correct.h"

SubCorrect::SubCorrect(bool *deldblspaces , bool *deleolspaces    , bool *delnumspaces, bool *cutcolorinfo, 
                       bool *blockshowtime, bool *placepunctuatuin, bool *dasharagement) : QDialog(NULL, "sub_showtime", true)
{

  this->deldblspaces     = deldblspaces;
  this->deleolspaces     = deleolspaces;
  this->delnumspaces     = delnumspaces;
  this->cutcolorinfo     = cutcolorinfo;
  this->blockshowtime    = blockshowtime;
  this->placepunctuatuin = placepunctuatuin;
  this->dasharagement    = dasharagement;


  QPushButton *btn_ok, *btn_cancel;
  btn_ok     = new QPushButton("OK", this);
  btn_cancel = new QPushButton("Anuluj", this);
  btn_ok    ->setGeometry(40 +45, 268, 80, 20);
  btn_ok    ->setDefault(true);
  btn_cancel->setGeometry(130+45, 268, 80, 20);
  connect(btn_ok    , SIGNAL(clicked()), SLOT(accept()));
  connect(btn_cancel, SIGNAL(clicked()), SLOT(reject()));

  QWidget *w1  = new QWidget (this);
  w1->setGeometry(10, 20, 230, 15);
  QLabel  *l1  = new QLabel  ("Popraw napisy:", w1);
  l1->setAutoResize(true);

  vbox1 = new QVBox(this);
  vbox1->setGeometry(10, 50, 320, 200);

  grp = new QButtonGroup(1, QGroupBox::Horizontal, "", vbox1);
  grp->setExclusive(false);
  b1 = new QCheckBox("&Usu wielokrotne spacje", grp);
  b2 = new QCheckBox("Usu spacje na kocach &wierszy", grp);
  b3 = new QCheckBox("Usu spacje midzy &cyframi", grp);
  b4 = new QCheckBox("Usu informacje o &kolorze (mDVDp)", grp);
  b5 = new QCheckBox("&Blokuj czas pokazywania napisu", grp);
  b6 = new QCheckBox("Popraw pozycje znakw &interpunkcyjnych", grp);
  b7 = new QCheckBox("Popraw pozycje znakw dialogu (mylnik)", grp);
  b1->setChecked(true);
  b2->setChecked(true);
  b3->setChecked(false);
  b4->setChecked(false);
  b5->setChecked(true);
  b6->setChecked(true);
  b7->setChecked(true);
};

//////////////////// SLOTY /////////////////
void SubCorrect::accept()
{
//  *this->enterempty      = b1->isChecked();
  done(true);
}
