int timeformat;

#define ADDSUBTITLETIME 2.0
#define DEFAULTSHOWTIME 3.0


#include "strcut.h"

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM //
// FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM //
// FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM //
// FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM //
// FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM //
// FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM //
////////////////////////////////////////////////////////////////////////////////
// sprawdza czy linia jest poprawna
int _isFRMlinecorrect (const char *linia)
{ // 1=OK   0=BAD
  int dlugosc = strlen (linia);
  if (dlugosc == 0)
    return 1;
  if (linia[0]!='{') return 0; // sprawdza pierwszy '{'
  if (linia[1]=='\0') return 0;
  if (linia[1]=='}') return 0;
  int poz; // pozycja w linii
  for (poz=1; poz<dlugosc; poz++) // szukanie pierwszego '}'
  {
    if (linia[poz]=='}') break; // znaleziono '}'
    if (poz==dlugosc-1) return 0; // w calej linii nie ma znaku '}'
  }
  poz++;
  if (linia[poz++]!='{') return 0; // drugi '{'
  if (!linia[poz]) return 0; // w calej linii nie ma drugiego znaku '}'
  for (poz; poz<dlugosc; poz++) // szukanie drugiego '}'
  {
    if (linia[poz]=='}') break; // znaleziono '}'
    if (poz==dlugosc-1) return 0; // w calej linii nie ma drugiego znaku '}'
  }
//  if (poz==dlugosc-1) return 0; // nie ma opisu dla linii           //########################################################################
  return 1;
}
////////////////////////////////////////////////////////////////////////////////
// zwraca ramke startowa z wyslanej linii
int _getstartfrm (const char *linia, char *wynik)
{ // 1=OK   0=BAD
  int dlugosc = strlen (linia);
  if (dlugosc == 0)
  {
    wynik[0]='\0';
    return 1;
  }
  int i; // pozycja '}'
  for (i=1; i<dlugosc; i++) // szukanie pierwszego '}'
    if (linia[i]=='}') break; // znaleziono '}'
  int j;
  for (j=0; j<i-1; j++)
    wynik[j]=linia[j+1];
  wynik[j]='\0';
  return 1;
}
////////////////////////////////////////////////////////////////////////////////
// zwraca ramke koncowa z wyslanej linii
int _getendfrm (const char *linia, char *wynik)
{ // 1=OK   0=BAD                          // uzywa   getstartfrm
  int dlugosc = strlen (linia);
  int i;
  for (i=1; i<dlugosc; i++) // szukanie pierwszego '}'
    if (linia[i]=='}') break; // znaleziono '}'
  i++;
  for (int j=0; j<dlugosc-i+1; j++)
    wynik[j]=linia[j+i];
  _getstartfrm(wynik, wynik);
  return 1;
}
////////////////////////////////////////////////////////////////////////////////
// zwraca tekst linii
int _getfrmtext (const char *linia, char *wynik)
{
  int dlugosc = strlen (linia);
  int i;
  for (i=1; i<dlugosc; i++) // szukanie pierwszego '}'
    if (linia[i]=='}') break; // znaleziono '}'
  i++;
  for (i; i<dlugosc; i++) // szukanie drugego '}'
    if (linia[i]=='}') break; // znaleziono '}'
  i++;
  for (int j=0; j<dlugosc-i+1; j++)
    wynik[j]=linia[j+i];
  return 1;
}
///////////////////////////////////////////////////////
// tworzy linie z podanych danych
int _putfrmline (int start, int end, char *text, char *wynik)
{
  char buf[15];

  gcvt(start, 10, buf);
  strcat( strcat( strcat( strcpy(wynik, "{"), buf), "}"), "{");
  if (end!=0)
  {
    gcvt(end, 10, buf);
    strcat (wynik, buf);
  }
  strcat( strcat (wynik, "}"), text);
  return 1;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL //
// MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL //
// MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL //
// MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL //
// MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL //
// MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL MPL //
////////////////////////////////////////////////////////////////////////////////
// sprawdza czy linia jest poprawna
int _isMPLlinecorrect (const char *linia)
{ // 1=OK   0=BAD
  int dlugosc = strlen (linia);
  if (dlugosc == 0)
    return 1;
  if (linia[0]!='[') return 0; // sprawdza pierwszy '['
  if (linia[1]=='\0') return 0;
  if (linia[1]==']') return 0;
  int poz; // pozycja w linii
  for (poz=1; poz<dlugosc; poz++) // szukanie pierwszego ']'
  {
    if (linia[poz]==']') break; // znaleziono ']'
    if (poz==dlugosc-1) return 0; // w calej linii nie ma znaku ']'
  }
  poz++;
  if (linia[poz++]!='[') return 0; // drugi ']'
  if (!linia[poz]) return 0; // w calej linii nie ma drugiego znaku '}'
  for (poz; poz<dlugosc; poz++) // szukanie drugiego ']'
  {
    if (linia[poz]==']') break; // znaleziono ']'
    if (poz==dlugosc-1) return 0; // w calej linii nie ma drugiego znaku ']'
  }
//  if (poz==dlugosc-1) return 0; // nie ma opisu dla linii           //########################################################################
  return 1;
}
////////////////////////////////////////////////////////////////////////////////
// zwraca ramke startowa z wyslanej linii
int _getstartMPL (const char *linia, char *wynik)
{ // 1=OK   0=BAD
  int dlugosc = strlen (linia);
  if (dlugosc == 0)
  {
    wynik[0]='\0';
    return 1;
  }
  int i; // pozycja '}'
  for (i=1; i<dlugosc; i++) // szukanie pierwszego '}'
    if (linia[i]==']') break; // znaleziono '}'
  int j;
  for (j=0; j<i-1; j++)
    wynik[j]=linia[j+1];
  wynik[j]='\0';
  return 1;
}
////////////////////////////////////////////////////////////////////////////////
// zwraca ramke koncowa z wyslanej linii
int _getendMPL (const char *linia, char *wynik)
{ // 1=OK   0=BAD                          // uzywa   getstartfrm
  int dlugosc = strlen (linia);
  int i;
  for (i=1; i<dlugosc; i++) // szukanie pierwszego '}'
    if (linia[i]==']') break; // znaleziono '}'
  i++;
  for (int j=0; j<dlugosc-i+1; j++)
    wynik[j]=linia[j+i];
  _getstartfrm(wynik, wynik);
  return 1;
}
////////////////////////////////////////////////////////////////////////////////
// zwraca tekst linii
int _getMPLtext (const char *linia, char *wynik)
{
  int dlugosc = strlen (linia);
  int i;
  for (i=1; i<dlugosc; i++) // szukanie pierwszego '}'
    if (linia[i]==']') break; // znaleziono '}'
  i++;
  for (i; i<dlugosc; i++) // szukanie drugego '}'
    if (linia[i]==']') break; // znaleziono '}'
  i++;
  for (int j=0; j<dlugosc-i+1; j++)
    wynik[j]=linia[j+i];
  return 1;
}
///////////////////////////////////////////////////////
// tworzy linie z podanych danych
int _putMPLline (int start, int end, char *text, char *wynik)
{
  char buf[15];
  gcvt(start, 10, buf);
  strcat( strcat( strcat( strcpy(wynik, "["), buf), "]"), "[");
  if (end!=0)
  {
    gcvt(end, 10, buf);
    strcat (wynik, buf);
  }
  strcat( strcat (wynik, "]"), text);
  return 1;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME //
// TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME //
// TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME //
// TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME //
// TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME //
// TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME TIME //
////////////////////////////////////////////////////////////////////////////////
// sprawdza czy linia jest poprawna
int _isTIMElinecorrect (const char *linia)
{ // 1=OK   0=BAD
// musi byc:  liczba ':' liczba ':' liczba ':'/' '
//  AnsiString line;
  if (*linia=='\0') return 1; // pusta linia tez jest oki
  int h, m, s, tf;
  _getstarttime(linia, tf, h, m, s, NULL);
  return (h>=0)&&(m>=0)&&(s>=0);
}
///////////////////////////////////////////////////////
// sprawdza czy linia jest == "0:00:00:"
int _lasttimeline (char *linia)
{
  return !strcmp(linia, "0:00:00:");
}
////////////////////////////////////////////////////////////////////////////////
// zwraca godzine, minute i sekunde z danej linii
int _getstarttime (const char *linia, int &tformat, int &h, int &m, int &s, char *tekst)
{
  QString line = linia;
                                                 ///////////////////////// CHECK 2002-02-19
  int poz;
  bool ok=false;
  h = QString(line.mid(0, poz = line.find(':'))).toInt(&ok);
    if (!ok) h=-1;
  poz++;    
  line = line.mid(poz);

  
  m = QString(line.mid(0, poz = line.find(':'))).toInt(&ok);
    if (!ok) m=-1;
  poz++;    
  line = line.mid(poz);

    poz = line.find(':');
    int rpoz = line.find('='); // ------------
    int lpoz = line.find(' ');
    if (((poz>lpoz)||(poz==-1))&&(lpoz!=-1)) poz = lpoz;
    if (((poz>rpoz)||(poz==-1))&&(rpoz!=-1)) poz = rpoz; // -----------
    if (poz==-1) poz = line.length();
  s = QString(line.mid(0, poz)).toInt(&ok); // sekunda napisu
    if (!ok) s=-1;

  poz++;
  line = line.mid(poz); // tekst napisu

  if (tekst!=0) strcpy(tekst, line.ascii());
  if (linia[1]==':') tformat = 2; else tformat = 1;

  return 1;
}
///////////////////////////////////////////////////////
// utworzenie nowej linii
int _puttimeline (int h, int m, int s, char *tekst, char *linia)
{
  if (timeformat==1)// 00:00:00:
  {
    char ch[5], cm[5], cs[5];
    linia[0]='\0';
    gcvt(h, 10, ch);
      if (strlen(ch)==1) strcat(linia, "0"); //  0:0
      strcat( strcat (linia, ch), ":"); //  0:
    gcvt(m, 10, cm);
      if (strlen(cm)==1) strcat(linia, "0"); //  0:0
      strcat( strcat (linia, cm), ":"); //  0:00:
    gcvt(s, 10, cs);
      if (strlen(cs)==1) strcat(linia, "0"); //  0:00:0
    strcat (linia, cs);
    strcat(linia , ":");
    strcat(linia , tekst);
    return 1;
  }
  if (timeformat==2)// 0:00:00:
  {
    char ch[5], cm[5], cs[5];
    gcvt(h, 10, ch);
      strcat( strcpy (linia, ch), ":"); //  0:
    gcvt(m, 10, cm);
      if (strlen(cm)==1) strcat(linia, "0"); //  0:0
      strcat( strcat (linia, cm), ":"); //  0:00:
    gcvt(s, 10, cs);
      if (strlen(cs)==1) strcat(linia, "0"); //  0:00:0
      strcat (linia, cs); //  0:00:00
      strcat(linia, ":"); //  0:00:00:
      strcat(linia, tekst); //  0:00:00:tekst
    return 1;
  }
  return 0;
}




////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// OGOLNE FUNKCJE DO NAPISOW  //// OGOLNE FUNKCJE DO NAPISOW
// OGOLNE FUNKCJE DO NAPISOW  //// OGOLNE FUNKCJE DO NAPISOW
// OGOLNE FUNKCJE DO NAPISOW  //// OGOLNE FUNKCJE DO NAPISOW
////////////////////////////////////////////////////////////////////////////////
// zwraca czas wyswietlania napisu na podstawie jego dlugosci
inline double getSubtitlesTime(char *text, double value)
{
  return (((double)strlen(text)/50.0)*value) + ADDSUBTITLETIME;
}

////////////////////////////////////////////////////////////////////////////////
// sprawdza czy linia jest w jednym z rozpoznawanych formatow
bool islineokay (char *linia)
{// 1:OK  0:ERR
  if (strlen(linia)<=5) return false; // pusta linia
     // bo jest w jednym z rozpoznawanych formatow
  if ( _isFRMlinecorrect (linia)||
       _isMPLlinecorrect (linia)||
       _isTIMElinecorrect(linia) ) return true;
  return false;
}

////////////////////////////////////////////////////////////////////////////////
// zwraca dane o linii napisow
bool getline (char *linia, int &format, double &showtime, double &hidetime, char *text)
{
  if (fps_value==0) fps_value = 1; // zeby nie bylo dzielenia przez zero
  if (_isFRMlinecorrect(linia)) // FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM FRM
  {
    _getstartfrm(linia, text);
     showtime = atoi(text)/fps_value; // poczatkowa klatka
    _getendfrm(linia, text);
     hidetime = atoi(text)/fps_value; // koncowa klatka
    _getfrmtext (linia, text); // napis
    format = 3;
  }
  else
  if (_isMPLlinecorrect(linia)) // MPL2 MPL2 MPL2 MPL2 MPL2 MPL2 MPL2 MPL2 MPL2
  {
    _getstartMPL(linia, text);
     showtime = atoi(text)/10.0; // poczatkowa klatka
    _getendMPL(linia, text);
     hidetime = atoi (text)/10.0; // koncowa klatka
    _getMPLtext (linia, text); // napis
    format = 4;
  }
  else
  if (_isTIMElinecorrect(linia)) // TIME TIME TIME TIME TIME TIME TIME TIME TIME
  {
    int h, m, s;
    _getstarttime (linia, format, h, m, s, text);
    showtime = h*3600+m*60+s;
    hidetime = 0;
  }
  else
  {
    format = 0;
    //qDebug("getline() error! Line format not recognized!!!");
    return false;
  }
  return true;
}

////////////////////////////////////////////////////////////////////////////////
// zwraca dane o linii oraz jej rzeczywisty czas wyswietlania z uwzglednieniem czasu wyswietlenia nastepnej linii
bool getrealline (char *linia, char *linia_nast, int &format, double &showtime, double &hidetime, char *text)
{
  if (!getline (linia, format, showtime, hidetime, text)) return false;
  if ( (hidetime==0)||(hidetime<=showtime) ) hidetime = showtime+getSubtitlesTime(text, DEFAULTSHOWTIME);

   double showtime2, hidetime2;
   char *text2 = new char [512];
   int format2;
    getline (linia_nast, format2, showtime2, hidetime2, text2);
   if(hidetime>showtime2) hidetime=showtime2;
   if(hidetime<showtime) hidetime = showtime;

   return true;
}

#include "sectimeservice.h"
////////////////////////////////////////////////////////////////////////////////
// f: 1_00: 2_0: 3_{0} 4_[0] 5_SSA
// utworzenie nowej linii
bool putline (int format, double showtime, double hidetime, char *text, char *linia)
{
  switch (format)
  {
    case 1: case 2: // 00:00:00:
      {
        timeformat = format;
        QString H, M, S;
        SecToTime    (showtime+.5, H, M, S);
        _puttimeline (H.toInt(), M.toInt(), S.toInt(), text, linia);
      }
      break;
    case 3:         // {000}{000}
      _putfrmline (showtime*fps_value +.5 , hidetime*fps_value +.5 , text, linia);
      break;
    case 4:         // [000][000]
      _putMPLline (showtime*10.0 +.5, hidetime*10.0 +.5, text, linia);
      break;
    default:
      qDebug("putline(): 'format' parametr error!!!");
      return false;
  }
  return true;
}
