#include <qdialog.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <qlabel.h>

#include "my_about.h"

#include "./graph/subedit.xpm"

MyAbout::MyAbout(QWidget *parent) : QDialog(parent, "my_about", true)
{
  QPixmap logo = QPixmap(subedit_xpm);

  QWidget *logoWdg = new QWidget(this);
  logoWdg->setGeometry(5, 20, logo.width(), logo.height());
  logoWdg->setBackgroundPixmap(subedit_xpm);


  QWidget *wdgl1 = new QWidget(this);
  wdgl1->setGeometry(25, logo.height()+20+10, logo.width()-25, 20);
  QLabel *l1 = new QLabel("Program do edycji napisw do filmw", wdgl1);
  l1->setAutoResize(true);


  QWidget *wdgl2 = new QWidget(this);
  wdgl2->setGeometry(25, logo.height()+20+30, logo.width()-25, 20);
  QLabel *l2 = new QLabel("(C) 2002 by Arthur Sikora", wdgl2);
  l2->setAutoResize(true);

  QWidget *wdgl3 = new QWidget(this);
  wdgl3->setGeometry(25, logo.height()+20+50, logo.width()-25, 20);
  QLabel *l3 = new QLabel("http://alfa.imi.pcz.czest.pl/~subedit", wdgl3);
  l3->setAutoResize(true);

  QPushButton *btn_ok;
  btn_ok = new QPushButton("OK", this);
  btn_ok->setGeometry((logo.width()+10)/2-40 ,20+85+logo.height(), 80, 20);
  btn_ok->setDefault(true);
  connect(btn_ok    , SIGNAL(clicked()), SLOT(accept()));

  
//  this->resize(300, 300);

  btn_ok->setFocus();
};

MyAbout::~MyAbout()
{
//  delete logoWdg;
//  delete wdgl1, wdgl2, wdgl3;
//  delete l1, l2, l3;
}
