#include <qwidget.h>
#include <qdialog.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qvbox.h>
#include <qbuttongroup.h>

#ifndef MY_SUB_SHOWTIME_H
#define MY_SUB_SHOWTIME_H

class SubShowtime : public QDialog
{
  Q_OBJECT
  public:
    SubShowtime(double *time, bool *enterempty, bool *changeonlyempty, bool *dependonlen, bool *blockshowtime);

  private slots:
    void        setEmpty();
    void	accept();

  private:
    double	 *time;
    bool	 *enterempty, *changeonlyempty, *dependonlen, *blockshowtime;
    
    QVBox        *vbox1;
    QCheckBox    *b1, *b2, *b3, *b4;
    QButtonGroup *grp;
    
    QLineEdit    *edit;
};

#endif
